;; Programs to show state of planar computations, uses globals in
;; planar*.lisp, where * is one of 1, 2, 3.  These programs are intended
;; for graphs with no more than 999 vertices.

(in-package '*lisp)

;; Display all edges, one per line

(defun disp-gr (&optional (printtriv ()))
 (if printtriv 
       (format t "  a   b  class  ntrve  Vup  Vdn       Uup          Udn~%")
       (format t "  a   b  class  Vup  Vdn       Uup          Udn~%"))
 (*when (and!! edgep prsnt (if printtriv t!! ntrve))
     (if printtriv (*if (not!! ntrve) (do-for-selected-processors (e)
       (format t "~3D ~3D  ~3D     ~1D      ~1D    ~1D    ~11,5E   ~11,5E~%"
               (pref edga e) (pref edgb e) -1 0 (b01 (pref Vup e))
               (b01 (pref Vdn e)) 0 0))))   
    (dotimes (ex Ncl)
      (*if (=!! edgc (!! ex))
         (do-for-selected-processors (e)
           (if printtriv 
              (format t "~3D ~3D  ~3D     ~1D      ~1D    ~1D    ~11,5E   ~11,5E~%"
               (pref edga e) (pref edgb e) ex (b01 (pref ntrve e)) (b01 (pref Vup e))
               (b01 (pref Vdn e)) (pref Uup e) (pref Udn e))
	      (format t "~3d ~3D  ~3D     ~1D    ~1D    ~11,5E   ~11,5E~%" 
		(pref edga e) (pref edgb e) ex (b01 (pref Vup e)) (b01 (pref Vdn e))
		(pref Uup e) (pref Udn e))))

  ) ;;end *if
 ) ;;end dotimes
) ;;end *when
) ;;end function

;; Convert Boolean to 0/1

(defun b01 (bx)
 (if bx 1 0)
)

;; PP Boolean pvar as 0/1

(*defun ppb (x) (ppp (if!! x (!! 1) (!! 0))))

;; Print current status

(defun status ()
  (let ((dissweep " "))
  (if alternate (if upsweep (setq dissweep "UP/DN") (setq dissweep "DN/UP"))
                (if upsweep (setq dissweep "UP") (setq dissweep "DN")))
  (format t "~A  A = ~G  B = ~G  Vertices: ~D  Max edges: ~D~%"
          program     A       B            nv           maxedges)
  (format t "Current- Legal: ~A  More: ~D  Cycles: ~D  Edges: ~D Sweep: ~A~%"
                       (btf legal)     more      cycles     totedges  dissweep)
) ;; end let
) ;; end function

;; Convert Boolean to T/F

(defun btf (bx) (if bx 'T 'F))



;; Display compact representation of graph determined by Xup, Xdn

(*defun disp-edges (Xup Xdn)
 (declare (type Boolean-pvar Xup Xdn))
 (let ((c 0) (cx 6))
   (*when (and!! edgep prsnt) (do-for-selected-processors (i)
      (format t "~3D-~3d " (pref edga i) (pref edgb i))
      (write-string (edgcode (pref Xup i) (pref Xdn i)))
      (incf c)
      (if (< c cx) (write-string "    ") (progn (terpri) (setq c 0)))
    )) ; end do-for-, end *when
 )
)

;; Compute symbol for edge determined by up dn

(defun edgcode (up dn)
 (if up (if dn "X" "U") (if dn "D" "."))
)


;; Display all interactions, one per line (intended only for testing)

(defun disp-inter ()
 (format t "ntra  ntrb    ntrc  ntrd~%")
 (*with-vp-set vpinter
   (*when intrp
     (do-for-selected-processors (ip)
       (format t "~4D  ~4D    ~4D  ~4D~%"
           (pref ntra ip) (pref ntrb ip) (pref ntrc ip) (pref ntrd ip)))
   )) ; end *when, end *with-vp-set
)

;; Run c cycles, reporting results

(defun run (c)
 (dotimes (i c) (print (cycle)))
 (terpri) (status)
)